# Generated by Django 3.2.5 on 2024-02-12 16:28

import django.contrib.postgres.constraints
import django.contrib.postgres.fields.ranges
from django.db import migrations, models
import django.db.models.constraints
import django.db.models.deletion
import lingua.fields


class Migration(migrations.Migration):

    dependencies = [
        ('sgpa', '0004_alter_tree_point'),
    ]

    operations = [
        migrations.CreateModel(
            name='TreeSymptomBranch',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_symptom_branch_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeSymptomCollar',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_symptom_collar_label')),
            ],
        ),
        migrations.AlterModelOptions(
            name='treestatus',
            options={'verbose_name_plural': 'Tree status'},
        ),
        migrations.RemoveField(
            model_name='treeepiphytehistory',
            name='epiphyte',
        ),
        migrations.RemoveField(
            model_name='treepathogenhistory',
            name='pathogen',
        ),
        migrations.RemoveField(
            model_name='treepesthistory',
            name='pest',
        ),
        migrations.RemoveField(
            model_name='treesymptomleavehistory',
            name='symptom',
        ),
        migrations.RemoveField(
            model_name='treesymptomroothistory',
            name='symptom',
        ),
        migrations.RemoveField(
            model_name='treesymptomtrunkhistory',
            name='symptom',
        ),
        migrations.AddField(
            model_name='treeepiphytehistory',
            name='epiphytes',
            field=models.ManyToManyField(to='sgpa.TreeEpiphyte'),
        ),
        migrations.AddField(
            model_name='treepathogenhistory',
            name='pathogens',
            field=models.ManyToManyField(to='sgpa.TreePathogen'),
        ),
        migrations.AddField(
            model_name='treepesthistory',
            name='pests',
            field=models.ManyToManyField(to='sgpa.TreePest'),
        ),
        migrations.AddField(
            model_name='treesymptomleavehistory',
            name='symptoms',
            field=models.ManyToManyField(to='sgpa.TreeSymptomLeave'),
        ),
        migrations.AddField(
            model_name='treesymptomroothistory',
            name='symptoms',
            field=models.ManyToManyField(to='sgpa.TreeSymptomRoot'),
        ),
        migrations.AddField(
            model_name='treesymptomtrunkhistory',
            name='symptoms',
            field=models.ManyToManyField(to='sgpa.TreeSymptomTrunk'),
        ),
        migrations.CreateModel(
            name='TreeSymptomCollarHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('symptoms', models.ManyToManyField(to='sgpa.TreeSymptomCollar')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='symptom_collar_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeSymptomBranchHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('symptoms', models.ManyToManyField(to='sgpa.TreeSymptomBranch')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='symptom_branch_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddConstraint(
            model_name='treesymptomcollarhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_symptom_collar_history'),
        ),
        migrations.AddConstraint(
            model_name='treesymptombranchhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_symptom_branch_history'),
        ),
    ]
